<?php
/**
  Plugin Name:        Iframe plus GET Parameters
  Description:        Pass GET parameters to your iframe. Shortcode like [iframex src="https://example.com" height="400"]
  Version:            1.0.1 
  Author:             Tron 
  Author URI:         https://tronusa.businessshop.net
  Author URI:         mailto:tronusa@businessshop.net?&subject=Iframex
  License:            GPL v2, written 2022
  License URI:        https://www.gnu.org/licenses/gpl-2.0.html
**/

require_once('row_meta.php'); 

if (!function_exists('iframex')) {
function iframex ($attrs_r, $content = null) { 

	$attrs_r = shortcode_atts( // default values if none passed
		array(
			'src' => '', 
			'name' => '',
			'id' => '', 
			//'title' => "An iframe", mabye add back in next version. 
			'sandbox' => '',
			'width' => '100%',
			'height' => '100',
				'frameborder' => '0', // 1 | 0 Deprecated in HTML5, but browsers still seem to support
				'scrolling' => 'no', // auto | yes | no
			'marginwidth' => '', // User should just use CSS for the rest of these
			'marginheight' => '',
			'longdesc' => '',
			'align' => '',
			'vspace' => ''
		), $attrs_r
	);
	
	foreach($attrs_r as $key => $value) {

		// $key = sanitize_text_field($key);  
		// Will have no effect as WordPress only allows the values in the array.
		
		$attrs_r[$key] = sanitize_text_field($value); 
	}
	
	if (empty(trim($attrs_r['src']))) 
		return "Please specify the URL.";

	// Get and santized all the variables in the URL. 
	$getVariables = "";
	foreach ($_GET as $key => $value) {
		$key = sanitize_text_field($key); 
		$value = sanitize_text_field(trim($value)); 
		if ( // Don't want to send these values to the page.
			$key == "submit" ||
			$key == "Submit" ||
			$key == "SUBMIT"  
		) continue;
		// Don't send empty fields. Need x_amount for special reasons. Even if empty. 
		// Maybe change this in next release. 
		if (empty($value) && $key != "x_amount") 
			continue;  
		$getVariables .= "$key=$value&";
	}
	
	// If iframe name specified add matching id tag if id is empty. 
	if (!empty($attrs_r['name']) && empty($attrs_r['id'])) 
		$attrs_r['id'] = trim($attrs_r['name']);
		
	$iframe_html = "
	<iframe 
		src='{$attrs_r['src']}?$getVariables' 
		name='{$attrs_r['name']}' 
		id='{$attrs_r['id']}' 
		width='{$attrs_r['width']}' 
		height='{$attrs_r['height']}' 
		frameborder='{$attrs_r['frameborder']}' 
		scrolling='{$attrs_r['scrolling']}' 
		
	 /></iframe>
	"; // onload='window.parent.parent.scrollTo(0,0)'
	return preg_replace(array("[\s+]"), " ", $iframe_html); 
	
}
add_shortcode('iframex', 'iframex'); 
}
